/*
 * MIT License
 *
 * Copyright (c) 2018-2020 Viktor Kireev
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

#pragma once

#define TOKEN_TEST_ENABLE_ASSERT
#define TOKEN_TEST_LOG_NOEXCEPT_x
#define OTN_NOEXCEPT_ALL_TRUE_x
#define OTN_NOEXCEPT_ALL_FALSE_x

#define OTN_STRICT
#define OTN_DEPRECATE_DEREFERENCE_OPTIONAL
#define OTN_DEPRECATE_MEMBER_OF_POINTER
#define OTN_DEPRECATE_SINGLE_BOOL
#define TOKEN_TEST_SUPPRESS_OTN_DEPRECATIONS

#define OTN_TEST_TOKEN_CONCEPT
#define OTN_TEST_TOKEN_CONSTRUCTION
#define OTN_TEST_TOKEN_ASSIGNMENT
#define OTN_TEST_TOKEN_INTEGRITY
#define OTN_TEST_TOKEN_MODIFICATION
#define OTN_TEST_TOKEN_OBSERVATION
#define OTN_TEST_TOKEN_NONMEMBER
#define OTN_TEST_TOKEN_HELPER

#ifdef OTN_TEST_TOKEN_CONCEPT
#define OTN_TEST_TOKEN_CONCEPT_TRAIT
#endif // OTN_TEST_TOKEN_CONCEPT

#ifdef OTN_TEST_TOKEN_CONSTRUCTION
#define OTN_TEST_TOKEN_CONSTRUCTION_DEFAULT
#define OTN_TEST_TOKEN_CONSTRUCTION_POINTER
#define OTN_TEST_TOKEN_CONSTRUCTION_ITSELF
#define OTN_TEST_TOKEN_CONSTRUCTION_COPY
#define OTN_TEST_TOKEN_CONSTRUCTION_MOVE
#endif // OTN_TEST_TOKEN_CONSTRUCTION

#ifdef OTN_TEST_TOKEN_ASSIGNMENT
#define OTN_TEST_TOKEN_ASSIGNMENT_COPY
#define OTN_TEST_TOKEN_ASSIGNMENT_MOVE
#endif // OTN_TEST_TOKEN_ASSIGNMENT

#ifdef OTN_TEST_TOKEN_INTEGRITY
#define OTN_TEST_TOKEN_INTEGRITY_TRACK
#endif // OTN_TEST_TOKEN_INTEGRITY

#ifdef OTN_TEST_TOKEN_MODIFICATION
#define OTN_TEST_TOKEN_MODIFICATION_SWAP
#endif // OTN_TEST_TOKEN_MODIFICATION

#ifdef OTN_TEST_TOKEN_OBSERVATION
#define OTN_TEST_TOKEN_OBSERVATION_BOOL
#define OTN_TEST_TOKEN_OBSERVATION_EXPIRED
#define OTN_TEST_TOKEN_OBSERVATION_LOCK
#define OTN_TEST_TOKEN_OBSERVATION_OWNER_BEFORE
#define OTN_TEST_TOKEN_OBSERVATION_VALUE
#endif // OTN_TEST_TOKEN_OBSERVATION

#ifdef OTN_TEST_TOKEN_NONMEMBER
#define OTN_TEST_TOKEN_NONMEMBER_COMPARISON
#endif // OTN_TEST_TOKEN_NONMEMBER

#ifdef OTN_TEST_TOKEN_HELPER
#define OTN_TEST_TOKEN_HELPER_ACCESS
#define OTN_TEST_TOKEN_HELPER_HASH
#endif // OTN_TEST_TOKEN_HELPER

// Debug
#define OTN_TEST_TOKEN_COMBINATION_x

#ifdef OTN_TEST_TOKEN_COMBINATION
#define OTN_TEST_TOKEN_COMBINATION_COUNT
#define OTN_TEST_TOKEN_COMBINATION_PRINT
#endif // OTN_TEST_TOKEN_COMBINATION
